// PSDセンサのアナログピン
#define PSD_F A3

// KP: Pゲイン, KD: Dゲイン
// **_NUM: 分子, **_DEN: 分母 を指定する
#define KP_NUM 3
#define KP_DEN 2
#define KI_NUM 1
#define KI_DEN 25
#define KD_NUM 1
#define KD_DEN 10

int refF = 300; // 目標値
int e = 0;       // 今の偏差
int ePrev = 0;  // 前の偏差
int eInt = 0;   // 偏差の積分値
int eDiff = 0;  // 偏差の微分値

// 偏差を返す関数
int getFrontDistanceError() {
  return e;
}

// 前の壁との距離を目標値制御する
void frontDistanceControl() {
  // PSDセンサの電圧をAD変換
  int valF = analogRead(PSD_F);

  // 目標値との偏差を計算する
  e = refF - valF;
  eInt += e / 50;
  eDiff = (e - ePrev) * 50;
  ePrev = e;

  // 前進指令値(PID)
  int v = e * KP_NUM / KP_DEN + eInt * KI_NUM / KI_DEN + eDiff * KD_NUM / KD_DEN;
  // 回転指令値(左回り正)
  int w = 0;

  // モータのPWMパルスを設定
  setMotorPulse(v - w, v + w);
}

// 制御入力を入れない
void endControl() {
  setMotorPulse(0, 0);
}
