// モータ駆動用のPWMピン
#define MOTOR_L_IN1 5
#define MOTOR_L_IN2 6
#define MOTOR_R_IN1 9
#define MOTOR_R_IN2 10

// モータのPWMを設定する関数
void setMotorPulse(int left, int right) {
  if(left > 0) {
    analogWrite(MOTOR_L_IN1, min(left, 255)); analogWrite(MOTOR_L_IN2, 0);
  } else {
    analogWrite(MOTOR_L_IN1, 0); analogWrite(MOTOR_L_IN2, min(-left, 255));
  }
  if(right > 0) {
    analogWrite(MOTOR_R_IN1, min(right, 255)); analogWrite(MOTOR_R_IN2, 0);
  } else {
    analogWrite(MOTOR_R_IN1, 0); analogWrite(MOTOR_R_IN2, min(-right, 255));
  }
}

// モータのPWMを設定する関数(PWM使用例2)
void setMotorPulse2(int left, int right) {
  if(left > 0) {
    analogWrite(MOTOR_L_IN1, 255); analogWrite(MOTOR_L_IN2,  max(255-left, 0));
  } else {
    analogWrite(MOTOR_L_IN1, max(255+left, 0)); analogWrite(MOTOR_L_IN2, 255);
  }
  if(right > 0) {
    analogWrite(MOTOR_R_IN1, 255); analogWrite(MOTOR_R_IN2,  max(255-right, 0));
  } else {
    analogWrite(MOTOR_R_IN1, max(255+right, 0)); analogWrite(MOTOR_R_IN2, 255);
  }
}
