unsigned long tPrev = 0; // 前の時刻

void setup() {
  Serial.begin(1000000);
  tPrev = millis();
}

#define CONTROL_ACTIVE 0
#define CONTROL_INACTIVE 1
int state = CONTROL_ACTIVE;

#define EPSILON 30        // 偏差の絶対値がEPSILONより小さければ収束と判定する
int convCount = 0; // 連続で収束と判定された回数

void loop() {
  // 状態ごとの処理
  switch(state) {
    case CONTROL_ACTIVE:
      frontDistanceControl();
      // 収束判定 収束したと連続で判定された回数を記録する
      if(abs(getFrontDistanceError()) < EPSILON) {
        convCount++;
      } else {
        convCount = 0;
      }
      break;
    case CONTROL_INACTIVE:
      endControl();
      break;
    default:
      break;
  }

  // 状態遷移
  switch(state) {
    case CONTROL_ACTIVE:
      // 50回以上(1秒以上)連続で収束と判定されたとき，CONTROL_INACTIVEへ遷移する
      if(convCount >= 50) {
        state = CONTROL_INACTIVE;
      }
      break;
    case CONTROL_INACTIVE:
      break;
    default:
      break;
  }

  // 処理時間を計算
  unsigned int tProc = millis() - tPrev;
  if(tProc < 20) {
    // 処理時間と合わせて20msになるようにdelayを入れる
    delay(20 - tProc);
  }
  tPrev = millis();
}
